local rev = tonumber(("$Revision: 78723 $"):match("(%d+)")) or 0
if rev > GuildCraft.version then GuildCraft.version = rev end

local function D(msg)
	if (not GuildCraft ) or (not GuildCraft.db.global.debug.comms) then return end
	ChatFrame1:AddMessage("|cff33FF66GC2-Comms:|r "..msg)
end


--[[  HOUSEKEEPING  ]]--
local addonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local module = addonParent:NewModule("CommsIO", "AceComm-3.0", "AceSerializer-3.0", "AceEvent-3.0") --Get Toys
module.rev = rev
local self_player = UnitName("player")
local Addon_Prefix = "GuildCraft"
module.cbh = LibStub("CallbackHandler-1.0"):New(module, "RegisterCommsCall", "UnregisterCommsCall")

function module:OnEnable()
	self:RegisterComm(Addon_Prefix)
	D("Communications Module Loaded")
end

local function DispatchComms(sender, result, command, ...)
	if not result then return end
	D("Dispatching Comms Command '"..command.."' from: "..sender)
	module.cbh:Fire(command, sender, ...)
end

function module:OnCommReceived(prefix, message, distribution, sender)
	if prefix ~= Addon_Prefix then return end
	DispatchComms(sender, self:Deserialize(message))
end


--[[  Support Calls & Outbound Communications  ]]--

local function Cerial(...)
	return module:Serialize(...)
end

function module:SendToGuild(...)
	if IsInGuild() then
		D("Sending To Guild".." '"..( tostring(select(1, ...)) ).."'" )
		module:SendCommMessage(Addon_Prefix, Cerial(...), "GUILD", nil, "BULK")
	end
end

function module:SendWhisper(player, ...)
	D("Sending Whisper to "..player.." "..( tostring(select(1, ...)) ) )
	module:SendCommMessage(Addon_Prefix, Cerial(...), "WHISPER", player, "BULK")
end

local embeds = {
	"SendToGuild",
	"SendWhisper",
	"RegisterCommsCall", 
	"UnregisterCommsCall"
}

function module:SoftEmbed(target)
	for i,v in ipairs(embeds) do
		target[v] = module[v]
	end
end
